`timescale 10ns / 1ns
module tb;

reg           clock;
always  #0.5  clock = ~clock;
initial begin clock = 0; #2000 $finish; end
initial begin $dumpfile("tb.vcd"); $dumpvars(0, tb); end

// ----------------
reg ps_clock = 1'b1;
reg ps_data  = 1'b1;

wire [7:0] keytest = 8'hF0;

initial begin

    // Старт-бит
    #8 ps_clock = 1'b0; ps_data = 1'b0;
    #3 ps_clock = 1'b1;
    // Биты данных
    #3 ps_clock = 1'b0; ps_data = keytest[0]; #3 ps_clock = 1'b1;
    #3 ps_clock = 1'b0; ps_data = keytest[1]; #3 ps_clock = 1'b1;
    #3 ps_clock = 1'b0; ps_data = keytest[2]; #3 ps_clock = 1'b1;
    #3 ps_clock = 1'b0; ps_data = keytest[3]; #3 ps_clock = 1'b1;
    #3 ps_clock = 1'b0; ps_data = keytest[4]; #3 ps_clock = 1'b1;
    #3 ps_clock = 1'b0; ps_data = keytest[5]; #3 ps_clock = 1'b1;
    #3 ps_clock = 1'b0; ps_data = keytest[6]; #3 ps_clock = 1'b1;
    #3 ps_clock = 1'b0; ps_data = keytest[7]; #3 ps_clock = 1'b1;
    // Бит четности
    #3 ps_clock = 1'b0; ps_data = ~^keytest; #3 ps_clock = 1'b1;
    // Стоп-бит
    #3 ps_clock = 1'b0; ps_data = 1'b1; #3 ps_clock = 1'b1;

end
// ----------------

ps2 Keyb
(
    .clock      (clock),
    .ps_clock   (ps_clock),
    .ps_data    (ps_data)
);

endmodule
